# $Id$

export ROOT_PASSWORD_DIALOG='
<window title="Root Password" icon-name="gtk-dialog-authentication" window_position="1" resizable="false">
	<vbox>
		<pixmap>
			<input file>data/header.png</input>
		</pixmap>
		<hbox spacing="160">
			<pixmap>
				<input file stock="gtk-dialog-authentication"></input>
			</pixmap>
			<text>
				<label>Enter root password</label>
			</text>
		</hbox>
		<frame root>
			<entry invisible_char="*" visibility="false">
				<input>echo "${ROOT_PASSWORD}"</input>
				<variable>ROOT_PASSWORD</variable>
			</entry>
			<entry invisible_char="*" visibility="false">
				<input>echo "${ROOT_PASSWORD_RETYPE}"</input>
				<variable>ROOT_PASSWORD_RETYPE</variable>
			</entry>
		</frame>
		<hbox>
			<button>
				<label>back</label>
				<input file stock="gtk-go-back"></input>
			</button>
			<button>
				<label>next</label>
				<input file stock="gtk-go-forward"></input>
			</button>
		</hbox>
	</vbox>
</window>
'
#<action signal="button-press-event">check_password "${ROOT_PASSWORD}" "${ROOT_PASSWORD_RETYPE}"</action>
#				<action type="closewindow">ROOT_PASSWORD</action>

export ADD_USER_DIALOG='
<window title="User add" icon-name="gtk-dialog-authentication" window_position="1" resizable="false">
	<vbox>
		<pixmap>
			<input file>data/header.png</input>
		</pixmap>
		<hbox spacing="100">
			<pixmap>
				<input file stock="gtk-dialog-authentication"></input>
			</pixmap>
			<text>
				<label>Please enter the name of a user</label>
			</text>
		</hbox>
		<frame username>
			<entry>
				<input>echo "${USER_NAME}"</input>
				<variable>USER_NAME</variable>
			</entry>
		</frame>
		<frame password>
			<entry invisible_char="*" visibility="false">
				<input>echo "${USER_PASSWORD}"</input>
				<variable>USER_PASSWORD</variable>
			</entry>
			<entry invisible_char="*" visibility="false">
				<input>echo "${USER_PASSWORD_RETYPE}"</input>
				<variable>USER_PASSWORD_RETYPE</variable>
			</entry>
		</frame>
		<hbox>
			<button>
				<label>back</label>
				<input file stock="gtk-go-back"></input>
			</button>
			<button>
				<label>next</label>
				<input file stock="gtk-go-forward"></input>
			</button>
		</hbox>
	</vbox>
</window>
'


check_password()
{
	local pass1="$1"
	local pass2="$2"

	debug "pass1='${pass1}'"

	if [[ -z ${pass1} ]]
	then
# 		echo "Empty Password given."
		FAILURE_MESSAGE="Empty password given!" rundialog FAILURE_DIALOG
		return 1
	fi

	if [[ ${pass1} = ${pass2} ]]
	then
# 		echo "Password match."
		return 0
	else
		FAILURE_MESSAGE="Password did not match!" rundialog FAILURE_DIALOG
# 		echo "DEBUG: pass1='${pass1}'"
# 		echo "DEBUG: pass2='${pass2}'"
# 		echo "Password did *not* match.
		return 1
	fi
}
# needed to be available in the gtk-dialog
export -f check_password


## main programm ##
rundialog_root_password_dialog()
{
	rundialog ROOT_PASSWORD_DIALOG
	debug "EXIT='${EXIT}'"

	# save given variables in env
	# they will be shown as default on error
	export ROOT_PASSWORD
	export ROOT_PASSWORD_RETYPE

	case ${EXIT} in
		abort)
			echo "Aborted by user."
			exit 1
			;;
		back)
			# placeholder
			return 1
			;;
		next)
			if ! check_password "${ROOT_PASSWORD}" "${ROOT_PASSWORD_RETYPE}"
			then
				rundialog_root_password_dialog
			fi
			;;
	esac
}

rundialog_add_user_dialog()
{
	rundialog ADD_USER_DIALOG
	debug "EXIT='${EXIT}'"

	# save given variables in env
	# they will be shown as default on error
	export USER_NAME
	export USER_PASSWORD
	export USER_PASSWORD_RETYPE

	case ${EXIT} in
		abort)
			echo "Aborted by user."
			exit 1
			;;
		back)
			rundialog_root_password_dialog
			rundialog_add_user_dialog
			;;
		next)
			if [[ -z ${USER_NAME} ]]
			then
				rundialog USERNAME_FAILURE
				rundialog_add_user_dialog
			fi
			if ! check_password "${USER_PASSWORD}" "${USER_PASSWORD_RETYPE}"
			then
				rundialog_add_user_dialog
			fi
			;;
	esac
}

main_usermanagement()
{
	rundialog_root_password_dialog
	rundialog_add_user_dialog

	# export all variables
	export ROOT_PASSWORD
	export USER_NAME
	export USER_PASSWORD
}
