#! /bin/bash
# $Id$

# global config
source /etc/installer.conf

# helper scripts
source ${INSTALLER_DIR}/include/functions.sh
source ${INSTALLER_DIR}/include/hwdetection.sh

# gui
source ${INSTALLER_DIR}/gtk-gui/common.sh
source ${INSTALLER_DIR}/gtk-gui/locales.sh
source ${INSTALLER_DIR}/gtk-gui/networking.sh
source ${INSTALLER_DIR}/gtk-gui/diskpartition.sh
source ${INSTALLER_DIR}/gtk-gui/usermanagement.sh
source ${INSTALLER_DIR}/gtk-gui/install.sh

# install root
INSTALL_ROOT="/mnt/magellan"

# setup if needed sudo
sudo=""
if [[ $(id -u) != 0 ]]
then
	SUDO=yes
	export sudo="sudo"
fi

rundialog()
{
	local i

	eval $(gtkdialog --program="$1")

# 	# export retvals automatically without RETVAL_ tag
# 	for i in $(set | grep RETVAL_ | cut -d= -f1)
# 	do
# 		export $(echo ${i} | sed "s:RETVAL_::")
# 	done
}
export -f rundialog

#### Helpers ####
##
## <text> -> center
## <text xalign=0> -> left
## <text xalign=2> -> right
##
## <list selection-mode="0"> -> no selection allowed; only default value
## <list selection-mode="1"> -> only one item can be selected; unselect allowed
## <list selection-mode="2"> -> only one item can be selected; no unselect allowed
## <list selection-mode="3"> -> multiple selections allowed
##
#################


#################################
#### Guification starts here ####
#################################

# # # start Xnest
# # Xnest :2 -ac -geometry 800x600 +kb &
# # # or start a full X11
# # #X :2 &
# # export DISPLAY=:2
# # 
# # # start openbox as windowmanager
# # export XDG_CONFIG_DIR=/etc/xdg
# # export XDG_DATA_DIR=/usr/share
# # sleep 1
# # exec openbox &


# set a reasonable background
sleep 0.1; fbsetbg -f ${INSTALLER_DIR}/data/background.png

# change into ${INSTALLER_DIR} to simplify gtkdialogs includes
pushd ${INSTALLER_DIR}

# start the program
rundialog WELCOME
#
main_locales
debug "RECEIVED: TIMEZONE_REGION='${TIMEZONE_REGION}'"
debug "RECEIVED: TIMEZONE_LOCATION='${TIMEZONE_LOCATION}'"
debug "RECEIVED: LOCALE_ALL='${LOCALE_ALL}'"
debug "RECEIVED: LOCALE='${LOCALE}'"

main_networking
debug "RECEIVED: NETWORK_HOSTNAME='${NETWORK_HOSTNAME}'"
debug "RECEIVED: NETWORK_DOMAIN='${NETWORK_DOMAIN}'"
debug "RECEIVED: NETWORK_NIC='${NETWORK_NIC}'"
debug "RECEIVED: NETWORK_METHOD='${NETWORK_METHOD}'"
debug "RECEIVED: NETWORK_IP='${NETWORK_IP}'"
debug "RECEIVED: NETWORK_NETMASK='${NETWORK_NETMASK}'"
debug "RECEIVED: NETWORK_BROADCAST='${NETWORK_BROADCAST}'"
debug "RECEIVED: NETWORK_GATEWAY='${NETWORK_GATEWAY}'"
debug "RECEIVED: NETWORK_NAMESERVER='${NETWORK_NAMESERVER}'"

main_diskpartition
debug "RECEIVED: PARTITION_DISK_SETUP='${PARTITION_DISK_SETUP}'"
debug "RECEIVED: PARTITION_DISK_ROOT='${PARTITION_DISK_ROOT}'"
debug "RECEIVED: PARTITION_FS_ROOT='${PARTITION_FS_ROOT}'"
debug "RECEIVED: PARTITION_DISK_BOOT='${PARTITION_DISK_BOOT}'"
debug "RECEIVED: PARTITION_FS_BOOT='${PARTITION_DISK_BOOT}'"
debug "RECEIVED: PARTITION_DISK_HOME='${PARTITION_DISK_HOME}'"
debug "RECEIVED: PARTITION_FS_HOME='${PARTITION_FS_HOME}'"
debug "RECEIVED: PARTITION_DISK_TMP='${PARTITION_DISK_TMP}'"
debug "RECEIVED: PARTITION_FS_TMP='${PARTITION_FS_TMP}'"
debug "RECEIVED: PARTITION_DISK_USER='${PARTITION_DISK_USER}'"
debug "RECEIVED: PARTITION_FS_USER='${PARTITION_FS_USER}'"
debug "RECEIVED: PARTITION_DISK_VAR='${PARTITION_DISK_VAR}'"
debug "RECEIVED: PARTITION_FS_VAR='${PARTITION_FS_VAR}'"
debug "RECEIVED: PARTITION_DISK_SVR='${PARTITION_DISK_SVR}'"
debug "RECEIVED: PARTITION_FS_SVR='${PARTITION_FS_SVR}'"
debug "RECEIVED: PARTITION_DISK_OPT='${PARTITION_DISK_OPT}'"
debug "RECEIVED: PARTITION_FS_OPT='${PARTITION_FS_OPT}'"
debug "RECEIVED: PARTITION_DISK_SWAP='${PARTITION_DISK_SWAP}'"
debug "RECEIVED: PARTITION_FS_SWAP='${PARTITION_DISK_SWAP}'"

main_usermanagement
debug "RECEIVED: ROOT_PASSWORD='${ROOT_PASSWORD}'"
debug "RECEIVED: USER_NAME='${USER_NAME}'"
debug "RECEIVED: USER_PASSWORD='${USER_PASSWORD}'"

main_install

# end of everything
rundialog FINISH

# get back
popd

exit 0
