#!/bin/sh

source /etc/installer.conf
source ${INSTALLER_DIR}/include/hwdetection.sh

# start Kdrive
KDRIVE_XSERVER=Xfbdev
KDRIVE_SCREENSIZE=1024x768x16

MOUSE_PATHES=$(get_evdev_device_path mouse)
KEYBOARD_PATHES=$(get_evdev_device_path keyboard)

MOUSE_DEVICES=""
for i in ${MOUSE_PATHES};
do
	MOUSE_DEVICES+=",device=${i}"
done

KEYBOARD_DEVICES=""
for i in ${KEYBOARD_PATHES};
do
	KEYBOARD_DEVICES+=",device=${i}"
done

KDRIVE_OPTS="-mouse evdev,${MOUSE_DEVICES}"
KDRIVE_OPTS+=" -keybd evdev,${KEYBOARD_DEVICES},xkblayout=de"
KDRIVE_OPTS+=" -fp /usr/share/fonts/75dpi,/usr/share/fonts/misc"
KDRIVE_OPTS+=" -zap -terminate -dpi 96"

[[ ${KDRIVE_XSERVER} = Xfbdev ]] && modprobe uvesafb

${KDRIVE_XSERVER} -screen ${KDRIVE_SCREENSIZE} ${KDRIVE_OPTS} &
export DISPLAY=:0
fluxbox -rc ${INSTALLER_DIR}/fluxbox/init &
sleep 1
xterm -C ${INSTALLER_DIR}/guification.sh &
##
