# $Id: locales.sh 1035 2010-05-30 18:37:54Z niro $

select_timezone_region()
{
	local items=( $(${INSTALLER_DIR}/include/timezone.sh --regions) )
	local count=${#items[*]}
	local i

	dialog \
		--stdout \
		--colors \
		--title "Setup TZ-Data" \
		--backtitle "${TITLE}" \
		--menu "Select a Region" \
		0 0 ${count} \
		$(for (( i=0; i<count; i++ )); do echo "${items[$i]} ."; done)

	return $?
}

select_timezone_location()
{
	local items=( $(${INSTALLER_DIR}/include/timezone.sh --locations ${TIMEZONE_REGION}) )
	local count=${#items[*]}
	local i

	dialog \
		--stdout \
		--colors \
		--title "Setup TZ-Data" \
		--backtitle "${TITLE}" \
		--menu "Select a Location" \
		0 0 ${count} \
		$(for (( i=0; i<count; i++ )); do echo "${items[$i]} ."; done)

	return $?
}

select_locale()
{
	local items=( $(${INSTALLER_DIR}/localedef --list-archive | grep $(include/timezone.sh --get-code ${TIMEZONE_LOCATION})) )
	local count=${#items[*]}
	local i

	dialog \
		--stdout \
		--colors \
		--backtitle "${TITLE}" \
		--menu "Select a default locale" \
		0 0 ${count} \
		$(for (( i=0; i<count; i++ )); do echo "${items[$i]} ."; done)

	return $?
}

rundialog_select_timezone_region()
{
	TIMEZONE_REGION=$(select_timezone_region)
	case $? in
		-1)	die "Error!" ;;
		255)	die "aborted by user" ;;

		1)
			rundialog_select_timezone_region
			;;

		0)	export TIMEZONE_REGION ;;
	esac

	debug "TIMEZONE_REGION='${TIMEZONE_REGION}'"
}

rundialog_select_timezone_location()
{
	TIMEZONE_LOCATION=$(select_timezone_location)
	case $? in
		-1)	die "Error!" ;;
		255)	die "aborted by user" ;;

		1)
			rundialog_select_timezone_region
			rundialog_select_timezone_location
			;;

		0)	export TIMEZONE_LOCATION ;;
	esac

	debug "TIMEZONE_LOCATION='${TIMEZONE_LOCATION}'"
}

rundialog_select_locale()
{
	LOCALE=$(select_locale)
	case $? in
		-1)	die "Error!" ;;
		255)	die "aborted by user" ;;

		1)
			rundialog_select_timezone_location
			rundialog_select_locale
			;;

		0)	export LOCALE ;;
	esac

	debug "LOCALE='${LOCALE}'"
}

main_locales()
{
	rundialog_select_timezone_region
	rundialog_select_timezone_location
	rundialog_select_locale
}
